Index: kernel/arch/sparc64/include/drivers/scr.h
===================================================================
--- kernel/arch/sparc64/include/drivers/scr.h	(revision 267ab565a400a2f05671ebf137daf78b42d99ab7)
+++ kernel/arch/sparc64/include/drivers/scr.h	(revision 9b35499759aea1863b4a5b9ea28a713e50adcb90)
@@ -42,5 +42,6 @@
 	SCR_UNKNOWN,
 	SCR_ATYFB,
-	SCR_FFB
+	SCR_FFB,
+	SCR_CGSIX
 } scr_type_t;
 
Index: kernel/arch/sparc64/src/drivers/scr.c
===================================================================
--- kernel/arch/sparc64/src/drivers/scr.c	(revision 267ab565a400a2f05671ebf137daf78b42d99ab7)
+++ kernel/arch/sparc64/src/drivers/scr.c	(revision 9b35499759aea1863b4a5b9ea28a713e50adcb90)
@@ -64,4 +64,6 @@
 	else if (strcmp(name, "SUNW,ffb") == 0)
 		scr_type = SCR_FFB;
+	else if (strcmp(name, "cgsix") == 0)
+		scr_type = SCR_CGSIX;
 	
 	if (scr_type == SCR_UNKNOWN) {
@@ -152,4 +154,22 @@
 
 		break;
+	case SCR_CGSIX:
+		switch (fb_depth) {
+		case 8:
+			fb_scanline = fb_linebytes;
+			visual = VISUAL_INDIRECT_8;
+			break;
+		default:
+			printf("Not implemented.\n");
+			return;
+		}
+		
+		ofw_sbus_reg_t *cg6_reg = &((ofw_sbus_reg_t *) prop->value)[0];
+		if (!ofw_sbus_apply_ranges(node->parent, cg6_reg, &fb_addr)) {
+			printf("Failed to determine screen address.\n");
+			return;
+		}
+	
+		break;
 	default:
 		panic("Unexpected type.\n");
Index: kernel/genarch/Makefile.inc
===================================================================
--- kernel/genarch/Makefile.inc	(revision 267ab565a400a2f05671ebf137daf78b42d99ab7)
+++ kernel/genarch/Makefile.inc	(revision 9b35499759aea1863b4a5b9ea28a713e50adcb90)
@@ -100,4 +100,5 @@
 		genarch/src/ofw/fhc.c \
 		genarch/src/ofw/pci.c  \
+		genarch/src/ofw/sbus.c \
 		genarch/src/ofw/upa.c 
 endif
Index: kernel/genarch/include/ofw/ofw_tree.h
===================================================================
--- kernel/genarch/include/ofw/ofw_tree.h	(revision 267ab565a400a2f05671ebf137daf78b42d99ab7)
+++ kernel/genarch/include/ofw/ofw_tree.h	(revision 9b35499759aea1863b4a5b9ea28a713e50adcb90)
@@ -141,4 +141,17 @@
 typedef struct ofw_pci_range ofw_pci_range_t;
 
+struct ofw_sbus_reg {
+	uint64_t addr;
+	uint32_t size;
+} __attribute__ ((packed));
+typedef struct ofw_sbus_reg ofw_sbus_reg_t;
+
+struct ofw_sbus_range {
+	uint64_t child_base;
+	uint64_t parent_base;
+	uint32_t size;
+} __attribute__ ((packed));
+typedef struct ofw_sbus_range ofw_sbus_range_t;
+
 struct ofw_upa_reg {
 	uint64_t addr;
@@ -161,4 +174,5 @@
 extern bool ofw_ebus_apply_ranges(ofw_tree_node_t *node, ofw_ebus_reg_t *reg, uintptr_t *pa);
 extern bool ofw_pci_apply_ranges(ofw_tree_node_t *node, ofw_pci_reg_t *reg, uintptr_t *pa);
+extern bool ofw_sbus_apply_ranges(ofw_tree_node_t *node, ofw_sbus_reg_t *reg, uintptr_t *pa);
 extern bool ofw_upa_apply_ranges(ofw_tree_node_t *node, ofw_upa_reg_t *reg, uintptr_t *pa);
 
Index: kernel/genarch/src/ofw/sbus.c
===================================================================
--- kernel/genarch/src/ofw/sbus.c	(revision 9b35499759aea1863b4a5b9ea28a713e50adcb90)
+++ kernel/genarch/src/ofw/sbus.c	(revision 9b35499759aea1863b4a5b9ea28a713e50adcb90)
@@ -0,0 +1,79 @@
+/*
+ * Copyright (c) 2007 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ofw
+ * @{
+ */
+/**
+ * @file
+ * @brief	SBUS 'reg' and 'ranges' properties handling.
+ *
+ */
+
+#include <genarch/ofw/ofw_tree.h>
+#include <macros.h>
+
+bool ofw_sbus_apply_ranges(ofw_tree_node_t *node, ofw_sbus_reg_t *reg,
+    uintptr_t *pa)
+{
+	ofw_tree_property_t *prop;
+	ofw_sbus_range_t *range;
+	count_t ranges;
+	
+	/*
+	 * The SBUS support is very rudimentary in that we simply assume
+	 * that the SBUS bus in question is connected directly to the UPA bus.
+	 * Should we come across configurations that need more robust support,
+	 * the driver will have to be extended to handle different topologies.
+	 */
+	if (!node->parent || node->parent->parent)
+		return false;
+	
+	prop = ofw_tree_getprop(node, "ranges");
+	if (!prop)
+		return false;
+		
+	ranges = prop->size / sizeof(ofw_sbus_range_t);
+	range = prop->value;
+	
+	int i;
+	
+	for (i = 0; i < ranges; i++) {
+		if (overlaps(reg->addr, reg->size, range[i].child_base,
+		    range[i].size)) {
+			*pa = range[i].parent_base +
+			    (reg->addr - range[i].child_base);
+			return true;
+		}
+	}
+	
+	return false;
+}
+
+/** @}
+ */
